/*
 * $Id: matrix.h,v 1.1 2010-05-02 14:16:34 laci Exp $
 *
 * Project      : RNA motif searching in genomic sequences
 * Description  : the header file for matrix.cpp
 *
 * Author       : Ladislav Rampasek <rampasek@gmail.com>
 * Institution  : Comenius University in Bratislava
 *
 */

#include <map>
#include <list>
using namespace std;

//data structure for dynamic programming
class Matrix{
    public:
        Matrix(){Matrix(1);};
        Matrix(unsigned int num_dimensions):num_dimensions(num_dimensions){};

        bool get(int num_args, ...);
        bool get(list<int> &key);
        void set(bool value, int num_args, ...);
        void set(bool value, list<int> &key);
        void clear(){ matrix.clear(); };
        bool empty(){ return matrix.empty(); };
        void set_dimensions(int new_num_dimensions){ num_dimensions=new_num_dimensions; clear(); };
    private:
        unsigned int num_dimensions;
        map<list<int>, bool> matrix;
};
